import java.awt.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Observable;
import java.util.Observer;

import javax.swing.*;

public class View extends JFrame implements Observer {
	
	private JCheckBoxMenuItem filter_blur, filter_distort, filter_sharpen, filter_contrast, filter_invert, filter_bw, filter_zoom;
	private JRadioButton allEffectsButton;
	private JButton randomButton;
	private JTextField filterTextField;
	
	ImageIcon image, image2;
	
	/**
	 * Constructor
	 */
	
	public View(Controller yapvController) 
	{
		this.setTitle("Medientechnik - olympiazentrum.png");
		
		// Creating the menu bar
		
		JMenuBar menuBar = new JMenuBar();
		
		JMenu menu = new JMenu("File");
		JMenuItem load = new JMenuItem("Load File");
		load.addActionListener(yapvController);
		load.setActionCommand("Load File");
		JMenuItem exit = new JMenuItem("Exit");
		exit.addActionListener(yapvController);
		exit.setActionCommand("Exit");
		menu.add(load);
		menu.addSeparator();
		menu.add(exit);
		menuBar.add(menu);
		
		JMenu filtermenu = new JMenu("Filters");
		filter_blur = new JCheckBoxMenuItem("Blur");
		filter_blur.addActionListener(yapvController);
		filter_blur.setActionCommand("filter_blur");
		filter_distort = new JCheckBoxMenuItem("Distort");
		filter_distort.addActionListener(yapvController);
		filter_distort.setActionCommand("filter_distort");
		filter_sharpen = new JCheckBoxMenuItem("Sharpen");
		filter_sharpen.addActionListener(yapvController);
		filter_sharpen.setActionCommand("filter_sharpen");
		filter_contrast = new JCheckBoxMenuItem("Contrast");
		filter_contrast.addActionListener(yapvController);
		filter_contrast.setActionCommand("filter_contrast");
		filter_invert = new JCheckBoxMenuItem("Invert");
		filter_invert.addActionListener(yapvController);
		filter_invert.setActionCommand("filter_invert");
		filter_bw = new JCheckBoxMenuItem("B/W");
		filter_bw.addActionListener(yapvController);
		filter_bw.setActionCommand("filter_bw");
		filter_zoom = new JCheckBoxMenuItem("Zoom");
		filter_zoom.addActionListener(yapvController);
		filter_zoom.setActionCommand("filter_zoom");
		filtermenu.add(filter_blur);
		filtermenu.add(filter_distort);
		filtermenu.add(filter_sharpen);
		filtermenu.add(filter_contrast);
		filtermenu.add(filter_invert);
		filtermenu.add(filter_bw);
		filtermenu.add(filter_zoom);
		//menu.addSeparator();
		//menu.add(exit);
		menuBar.add(filtermenu);
		
		JMenu about = new JMenu("About");
		JMenuItem about_yapv = new JMenuItem("Medientechnik");
		about_yapv.addActionListener(yapvController);
		about.add(about_yapv);
		menuBar.add(about);
		
		this.setJMenuBar(menuBar);
		
		//---------------------------------------------------------------------------
		// Main content panel with BorderLayout
		
		JPanel content = new JPanel();
		content.setLayout(new BorderLayout());
		this.getContentPane().add(content);

		//---------------------------------------------------------------------------
		// Picture panel with GridBagLayout
		
		JPanel pictures = new JPanel();
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.CENTER;

		pictures.setLayout(new GridBagLayout());
		
		try {
			image = new ImageIcon(new URL("http://www.inspectorspyware.com/images/error_x.jpg"));
			image2 = new ImageIcon(new URL("http://www.inspectorspyware.com/images/error_x.jpg"));
			
			// Because image2 will be an edited version of image we'll take image.getWidth() and multiply it
			// Also scaling two different images won't be necessary (in future) 
			
			double screenWidth = Toolkit.getDefaultToolkit().getScreenSize().getWidth();
			double screenHeight = Toolkit.getDefaultToolkit().getScreenSize().getHeight();
			
			// 30px for window borders...
			if ((image.getImage().getWidth(null)*2 + 30) > screenWidth)
			{
				double scale = (screenWidth - 30) / (image.getImage().getWidth(null)*2);
				int newWidth =  (int)(scale * image.getImage().getWidth(null));
				int newHeight = (int)(scale * image.getImage().getHeight(null));
				
				Image tmpImage = image.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image.setImage(tmpImage);
				
				tmpImage = image2.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image2.setImage(tmpImage);
				
			}
			
			// 150px for effect panel, menu bar, window borders...
			if (image.getImage().getHeight(null) + 150 > screenHeight)
			{
				double scale = (screenHeight - 150) / (image.getImage().getHeight(null));
				int newWidth =  (int)(scale * image.getImage().getWidth(null));
				int newHeight = (int)(scale * image.getImage().getHeight(null));
				
				Image tmpImage = image.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image.setImage(tmpImage);
				
				tmpImage = image2.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image2.setImage(tmpImage);
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		
		
		JLabel img_label = new JLabel(image);
		JLabel img_label2 = new JLabel(image2);
		image.setImageObserver(img_label);
		image2.setImageObserver(img_label2);
		c.weightx = 0.5;
		c.gridx = 0;
		c.gridy = 0;
        pictures.add(img_label, c);
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 0;
        pictures.add(img_label2, c);
        c.weightx = 0.5;
        c.gridx = 0;
        c.gridy = 1;
        pictures.add(new JLabel("Original"), c);
        c.weightx = 0.5;
        c.gridx = 1;
        c.gridy = 1;
        pictures.add(new JLabel("Preview"), c);
        content.add(pictures, BorderLayout.NORTH);
        
        // Separator
        
        JSeparator separator = new JSeparator(JSeparator.HORIZONTAL);
        content.add(separator, BorderLayout.CENTER);
 
        
		//---------------------------------------------------------------------------        
        // Panel for buttons & checkboxes with FlowLayout
        
        JPanel allEffects = new JPanel();
        allEffects.setLayout(new FlowLayout());
        
        allEffectsButton = new JRadioButton("Alle Effekte");
        allEffectsButton.setSelected(false);
        allEffectsButton.addActionListener(yapvController);
        
       JLabel effect_label = new JLabel("Filters:");
       
       filterTextField = new JTextField(100);
       filterTextField.setEditable(false);
       
       randomButton = new JButton("Random");
       randomButton.addActionListener(yapvController);
        
       allEffects.add(allEffectsButton);
       allEffects.add(randomButton);
       allEffects.add(effect_label);
       allEffects.add(filterTextField);

	    
		content.add(allEffects, BorderLayout.SOUTH);
		
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.pack();
		this.setVisible(true);
	}
	
	/**
	 * Opens a message dialog with information about the author of this program.
	 */
	
	public void showAbout()
	{
		JOptionPane.showMessageDialog(this," Max Mustermann", "YaPV - Yet another Picture Viewer", JOptionPane.WARNING_MESSAGE);
	}
	
	public void update(Observable o, Object arg1) {
		Model model = (Model) o;
		
		//BEGIN: Updating the images, if required
		if (model.receivedNewImage())
		{
			image.setImage(model.getImage());
			image2.setImage(model.getImage2());
						
			double screenWidth = Toolkit.getDefaultToolkit().getScreenSize().getWidth();
			double screenHeight = Toolkit.getDefaultToolkit().getScreenSize().getHeight();
						
			// 30px for window borders...
			if ((image.getImage().getWidth(null)*2 + 30) > screenWidth)
			{
				double scale = (screenWidth - 30) / (image.getImage().getWidth(null)*2);
				int newWidth =  (int)(scale * image.getImage().getWidth(null));
				int newHeight = (int)(scale * image.getImage().getHeight(null));
				
				Image tmpImage = image.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image.setImage(tmpImage);
				
				tmpImage = image2.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image2.setImage(tmpImage);
				
			}
			
			// 150px for effect panel, menu bar, window borders...
			if (image.getImage().getHeight(null) + 150 > screenHeight)
			{
				double scale = (screenHeight - 150) / (image.getImage().getHeight(null));
				int newWidth =  (int)(scale * image.getImage().getWidth(null));
				int newHeight = (int)(scale * image.getImage().getHeight(null));
				
				Image tmpImage = image.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image.setImage(tmpImage);
				
				tmpImage = image2.getImage().getScaledInstance(newWidth, newHeight, Image.SCALE_SMOOTH);
				image2.setImage(tmpImage);
			}
		
			this.pack();
			
			
			//BEGIN: Updating the title
				this.setTitle("YetAnotherPictureProgram MT11 - " + model.getName());
			//END: Updating the titles			
				
			this.repaint();
		}
		//END: Updating the images
		
		//BEGIN: Update filter-buttons and text-field
		String filter_text = "";
		
		
		// there is no button-functionality without any images loaded
		if (model.noImageYet()) {
			allEffectsButton.setEnabled(false);
			randomButton.setEnabled(false);
			filter_blur.setEnabled(false);
			filter_distort.setEnabled(false);
			filter_sharpen.setEnabled(false);
			filter_contrast.setEnabled(false);
			filter_invert.setEnabled(false);
			filter_bw.setEnabled(false);
			filter_zoom.setEnabled(false);
		}
		else{
			allEffectsButton.setEnabled(true);
			randomButton.setEnabled(true);
			filter_blur.setEnabled(true);
			filter_distort.setEnabled(true);
			filter_sharpen.setEnabled(true);
			filter_contrast.setEnabled(true);
			filter_invert.setEnabled(true);
			filter_bw.setEnabled(true);
			filter_zoom.setEnabled(true);
		}

		if (model.isBlur()) {
			filter_blur.setSelected(true);
			filter_text += " Blur";
		}
		else filter_blur.setSelected(false);
		
		if (model.isDistort()) {
			filter_distort.setSelected(true);
			filter_text += " Distortion";
		}
		else filter_distort.setSelected(false);
		
		if (model.isSharpen()) {
			filter_sharpen.setSelected(true);
			filter_text += " Sharpen";
		}
		else filter_sharpen.setSelected(false);
			
		if (model.isContrast()) {
			filter_contrast.setSelected(true);
			filter_text += " Contrast";
		}
		else filter_contrast.setSelected(false);
		
		if (model.isInvert()) {
			filter_invert.setSelected(true);
			filter_text += " Invert";
		}
		else filter_invert.setSelected(false);
		
		if (model.isBW()) {
			filter_bw.setSelected(true);
			filter_text += " B/W";
		}
		else filter_bw.setSelected(false);
		
		if (model.isZoom()) {
			filter_zoom.setSelected(true);
			filter_text += " Zoom";
		}
		else filter_zoom.setSelected(false);
		
		filterTextField.setText(filter_text);
		//END: Update filter-buttons and text-field
	}
}
